// SendSMS.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "SendSMS.h"
#include <tchar.h>
#include <commctrl.h>
#include <commdlg.h>
#include <CS.h>
#include <CSO.h>
#include <CVect.h>
#ifdef	_WIN32_WCE
#include <COShellAPI.h>
#include <GetDisk.h>
#include <pimdb.h>
#include <Sipapi.h>
#endif

#define MAX_LOADSTRING 100

// Global variable :
TCHAR		szTitle[MAX_LOADSTRING];			// Title bar text
TCHAR		szWindowClass[MAX_LOADSTRING];		// Title bar text
HINSTANCE	hInst;								// The current instance

// the function that 
void FilenameCutFileName(TCHAR *fileName)
{
	TCHAR *ptr = fileName + _tcslen(fileName);
	while(1){
		ptr--;
		if ((*ptr == _T('\\')) || (*ptr == _T('/'))){
			*(++ptr) = _T('\0');
			break;
		}
		else if ((*ptr == _T('\0')) || (ptr == fileName)){
			break;
		}
	}

	return;
}

// the function that creates the cassio specific toolbar control
// for the program main window
HWND casioCSOBar(HWND hWnd, HINSTANCE hInstance)
{
	// toolbar definition structures

	// toolbar definition
	CSOBAR_BASEINFO		baseInfo = {
		(-1),										// x
		(-1),										// y
		(-1),										// width
		(-1),										// height
		1,											// line
		CSOBAR_DEFAULT_BACKCOLOR,					// backColor
		CSOBAR_DEFAULT_CODECOLOR,					// titleColor
		NULL,										// titleText
		NULL,										// titleBmpResId
		NULL,										// titleBmpResIns
	};

	// the buttons definition
	CSOBAR_BUTTONINFO	buttonInfo[] = {

		// left arrow button
		ID_LEFT_ARROW,								// idCommand
		CSOBAR_BUTTON_NORM,							// fsStyle
		CSO_BUTTON_DISP,							// fsState
		(-1),										// iBitmap
		NULL,										// reshInst
		NULL,										// FaceText
		NULL,										// SubMenu
		0,											// codePos
		1,											// linePos
		(-1),										// x
		(-1),										// y
		(-1),										// width
		(-1),										// height
		{											// btnExStyle
			CSO_ID_BACK,							//   BtnID
			CLR_INVALID,							//   FaceColor
			CLR_INVALID,							//   TextColor
			CLR_INVALID,							//   TransparentColor
			FALSE,									//   Bold
			FALSE,									//   Italic
		},

		// setup button
		ID_SETUP,									// idCommand
		CSOBAR_BUTTON_NORM,							// fsStyle
		CSO_BUTTON_DISP,							// fsState
		NULL,										// iBitmap
		NULL,										// reshInst
		NULL,										// FaceText
		NULL,										// SubMenu
		0,											// codePos
		1,											// linePos
		(-1),										// x
		(-1),										// y
		(-1),										// width
		(-1),										// height
		{											// btnExStyle
			0,										//   BtnID
			CLR_INVALID,							//   FaceColor
			CLR_INVALID,							//   TextColor
			CLR_INVALID,							//   TransparentColor
			FALSE,									//   Bold
			FALSE,									//   Italic
		},
	};

	// create toolbar 
	HWND hWndBar = CSOBar_Create(hInstance, hWnd, 1, baseInfo);
	if(hWndBar == NULL){
		DestroyWindow(hWndBar);
		return(NULL);
	}

	// set text for the setup button
	TCHAR szFaceText[256];
	LoadString(hInstance, IDS_SETUP, 
			   szFaceText, sizeof(szFaceText)/sizeof(TCHAR));
	buttonInfo[1].FaceText = szFaceText;
	
	// add left arrow and setup buttons as well as help and close buttons
	if ((CSOBar_AddButtons(hWndBar, hInstance, 2, buttonInfo) == FALSE) ||
		(CSOBar_AddAdornments(hWndBar, hInstance, 1, CSOBAR_ADORNMENT_CLOSE | CSOBAR_ADORNMENT_HELP, 0) == FALSE)){
		CSOBar_Destroy(hWndBar);
		DestroyWindow(hWnd);
		return(NULL);
	}

#ifndef	_WIN32_WCE
	{
		DWORD style = GetWindowLong(hWndBar, GWL_STYLE);
		style &= ~WS_CLIPCHILDREN;
		SetWindowLong(hWndBar, GWL_STYLE, style);
	}
#endif

	return(hWndBar);
}

// the function that creates the cassio specific toolbar control
// for the setup dialog window
HWND dialogCSOBar(HWND hWnd, HINSTANCE hInstance)
{
	// toolbar definition structures

	// toolbar definition
	CSOBAR_BASEINFO		baseInfo = {
		(-1),										// x
		(-1),										// y
		(-1),										// width
		(-1),										// height
		1,											// line
		CSOBAR_DEFAULT_BACKCOLOR,					// backColor
		CSOBAR_DEFAULT_CODECOLOR,					// titleColor
		NULL,										// titleText
		NULL,										// titleBmpResId
		NULL,										// titleBmpResIns
	};

	// the buttons definition
	CSOBAR_BUTTONINFO	buttonInfo[] = {
		// OK button
		IDOK,										// idCommand
		CSOBAR_BUTTON_NORM,							// fsStyle
		CSO_BUTTON_DISP,							// fsState
		(-1),										// iBitmap
		NULL,										// reshInst
		NULL,										// FaceText
		NULL,										// SubMenu
		0,											// codePos
		1,											// linePos
		(-1),										// x
		(-1),										// y
		(-1),										// width
		(-1),										// height
		{											// btnExStyle
			CSO_ID_BACK,							//   BtnID
			CLR_INVALID,							//   FaceColor
			CLR_INVALID,							//   TextColor
			CLR_INVALID,							//   TransparentColor
			FALSE,									//   Bold
			FALSE,									//   Italic
		},

		// Cancel button
		IDCANCEL,									// idCommand
		CSOBAR_BUTTON_NORM,							// fsStyle
		CSO_BUTTON_DISP,							// fsState
		NULL,										// iBitmap
		NULL,										// reshInst
		NULL,										// FaceText
		NULL,										// SubMenu
		0,											// codePos
		1,											// linePos
		(-1),										// x
		(-1),										// y
		(-1),										// width
		(-1),										// height
		{											// btnExStyle
			0,										//   BtnID
			CLR_INVALID,							//   FaceColor
			CLR_INVALID,							//   TextColor
			CLR_INVALID,							//   TransparentColor
			FALSE,									//   Bold
			FALSE,									//   Italic
		},
	};

	// create toolbar 
	HWND hWndBar = CSOBar_Create(hInstance, hWnd, 1, baseInfo);
	if(hWndBar == NULL){
		DestroyWindow(hWndBar);
		return(NULL);
	}

	// set text for the cancel button
	TCHAR szFaceText[256];
	LoadString(hInstance, IDS_CANCEL, 
			   szFaceText, sizeof(szFaceText)/sizeof(TCHAR));
	buttonInfo[1].FaceText = szFaceText;
	
	// add OK and Cancel buttons
	if (CSOBar_AddButtons(hWndBar, hInstance, 2, buttonInfo) == FALSE){
		CSOBar_Destroy(hWndBar);
		DestroyWindow(hWnd);
		return(NULL);
	}

#ifndef	_WIN32_WCE
	{
		DWORD style = GetWindowLong(hWndBar, GWL_STYLE);
		style &= ~WS_CLIPCHILDREN;
		SetWindowLong(hWndBar, GWL_STYLE, style);
	}
#endif

	return(hWndBar);
}

// the function that fill in the drop down list control by contactes from 
// the embeded PIM database
void GetContacts(HWND hWndAddresses)
{
	// open the contacts database
	HANDLE hContacts = pim_OpenDatabase(NULL, PIM_DBID_CONTACTS, FALSE);

	if (hContacts != NULL)
	{
		DWORD dwIndex = 0; 
		FILETIME ftModified;
		DWORD dwSeekType = PIMDB_SEEK_BEGINNING;
		CEOID idRecord = NULL;
		
		// look over the database entries
		while ((idRecord = pim_SeekDatabase(hContacts, dwSeekType,
											0, &ftModified, &dwIndex)) != NULL)
		{
			WORD     wPropCount = 0;
			CEPROPID rgProps[3] = { HHPR_LISTNAME, HHPR_MOBILE_TELEPHONE_NUMBER, 0 };

			DWORD	 dwSize = 1024;
			LPBYTE   lpBuffer = (LPBYTE)LocalAlloc(LMEM_FIXED, dwSize);
			if (! lpBuffer) break;
 
			// get list name and mobile phone for the contact
			if (pim_ReadRecordProps(hContacts, &wPropCount, NULL/*rgProps*/, 
									&lpBuffer, &dwSize) == NULL)
				{ LocalFree(lpBuffer); lpBuffer = NULL;	}

			if (! lpBuffer) break;
			
			TCHAR szListName[256] = _T(""), szPhoneNum[256] = _T("");

			for (int i=0; i<wPropCount; i++) 
			{
				CEPROPID propid = ((CEPROPVAL*)lpBuffer)[i].propid;
				switch (propid) 
				{
					case HHPR_LISTNAME:
						lstrcpy(szListName, ((CEPROPVAL*) lpBuffer)[i].val.lpwstr);
						break;

					case HHPR_MOBILE_TELEPHONE_NUMBER:
						lstrcpy(szPhoneNum, ((CEPROPVAL*) lpBuffer)[i].val.lpwstr);
						break;

					default:
						break;
				}
			}
  
			LocalFree(lpBuffer);

			// check  that the contact has both the list name and the mobile phone
			if ((lstrlen(szListName) > 0) && (lstrlen(szPhoneNum) > 0))
			{
				// it has
				
				// insert the item to list
				LRESULT lIndex = SendMessage(hWndAddresses, CB_INSERTSTRING, -1, (LPARAM)szListName);

				// store the phone number as list item data
				TCHAR *lpszPhone = (TCHAR *)LocalAlloc(LMEM_FIXED, (lstrlen(szPhoneNum)+1)*sizeof(TCHAR));
				if (lpszPhone) lstrcpy(lpszPhone, szPhoneNum);
				SendMessage(hWndAddresses, CB_SETITEMDATA, lIndex, (LPARAM)lpszPhone);
			}
 
			// go to next contact in database
			dwSeekType = PIMDB_SEEK_NEXT;
		}
		
		// close the database handle
		pim_CloseDatabase(hContacts);
	}
}

// the function that creates controls in the program main window
BOOL createControls(HWND hWnd, HINSTANCE hInstance, HWND hWndControls[])
{
	TCHAR szText[256] = _T("");
	LoadString(hInst, IDS_ADDRESS_STRING,
			   szText, sizeof(szText)/sizeof(TCHAR));

	hWndControls[0] = 
		CreateWindow(TEXT("STATIC"), szText,
					 WS_CHILD | WS_VISIBLE | SS_LEFT, 
					 0, 0, 10, 10, hWnd, NULL, hInst, NULL);
	hWndControls[1] = 
		CreateWindow(TEXT("COMBOBOX"), NULL, 
					 WS_CHILD | WS_BORDER | WS_VISIBLE | WS_TABSTOP | CBS_DROPDOWN, 
					 0, 0, 10, 10, hWnd, (HMENU)ID_RECIPIENT_CB, hInst, NULL);

	if ((hWndControls[1]) == NULL)
	{
		DestroyWindow(hWnd);
		return FALSE;
	}

	GetContacts(hWndControls[1]);

	LoadString(hInst, IDS_MESSAGE_STRING,
			   szText, sizeof(szText)/sizeof(TCHAR));

	hWndControls[2] = 
		CreateWindow(TEXT("STATIC"), szText,
					 WS_CHILD | WS_VISIBLE | SS_LEFT, 
					 0, 0, 10, 10, hWnd, NULL, hInst, NULL);

	hWndControls[3] = 
		CreateWindow(TEXT("EDIT"), NULL, 
				   WS_CHILD | WS_BORDER | WS_VISIBLE | WS_TABSTOP |
				   ES_MULTILINE | ES_AUTOVSCROLL | ES_WANTRETURN | WS_VSCROLL, 
				   0, 0, 10, 10, hWnd, (HMENU)ID_TEXT_EDIT, hInst, NULL);


	if ((hWndControls[3]) == NULL)
	{
		DestroyWindow(hWnd);
		return FALSE;
	}

	return TRUE;
}

void sizeControls(HWND hWnd, int top, HWND hWndControls[])
{
	RECT rcParent; GetClientRect(hWnd, &rcParent);

	HDC hDC = GetWindowDC(hWnd);
	TEXTMETRIC tm; GetTextMetrics(hDC, &tm);
	int yText = tm.tmHeight + tm.tmHeight/2;
	ReleaseDC(hWnd, hDC);

	MoveWindow(hWndControls[0], rcParent.left, top, 
			   rcParent.right - rcParent.left, yText, 
			   TRUE);
	top += yText;

	MoveWindow(hWndControls[1], rcParent.left, top, 
			   rcParent.right - rcParent.left,  
			   rcParent.bottom - top, 
			   TRUE);

	RECT rcComboBox;
	GetWindowRect(hWndControls[1], &rcComboBox);
	top += rcComboBox.bottom - rcComboBox.top;

	MoveWindow(hWndControls[2], rcParent.left, top, 
			   rcParent.right - rcParent.left, yText, 
			   TRUE);
	top += yText;

	MoveWindow(hWndControls[3], rcParent.left, top, 
			   rcParent.right - rcParent.left, 
			   rcParent.bottom - top, TRUE);
}

// Pre-declaration of the function contained in this code module :
ATOM				MyRegisterClass	(HINSTANCE, LPTSTR);
BOOL				InitInstance	(HINSTANCE, int);
LRESULT CALLBACK	WndProc			(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	SetupDlgProc(HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
#ifdef	_WIN32_WCE
					LPTSTR    lpCmdLine,
#else
					LPSTR     lpCmdLine,
#endif
					int       nCmdShow)
{
	MSG msg;
	HACCEL hAccelTable;

	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_SENDSMS, szWindowClass, MAX_LOADSTRING);

	// Application is initialized.   :
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_SENDSMS);

	// Main Message Loop :
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}


//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    It is important to call this function so that the application 
//    will get 'well formed' small icons associated with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS	wc;

    wc.style			= CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_SENDSMS));
#ifdef	_WIN32_WCE
    wc.hCursor			= 0;
#else
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
#endif
    wc.hbrBackground	= (HBRUSH) GetStockObject(WHITE_BRUSH);
#ifdef	_WIN32_WCE
    wc.lpszMenuName		= 0;
#else
	wc.lpszMenuName		= 0;
#endif
    wc.lpszClassName	= szWindowClass;

	return RegisterClass(&wc);
}

//
//  FUNCTION: InitInstance(HANDLE, int)
//
//  PURPOSE: Saves instance handle and creates main window
//
//  COMMENTS:
//
//    In this function, we save the instance handle in a global variable and
//    create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND	hWnd;
#ifdef	_WIN32_WCE
	DWORD	dwStyle = WS_VISIBLE;
#else
	DWORD	dwStyle = WS_OVERLAPPEDWINDOW;
#endif

	hInst = hInstance;		// An instance handle is saved at a global variable.
	MyRegisterClass(hInstance, szWindowClass);

	hWnd = CreateWindow(szWindowClass, szTitle, dwStyle,
						CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, 
						NULL, NULL, hInstance, NULL);

	if (!hWnd)
	{	
		return FALSE;
	}

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	return TRUE;
}

BOOL GetRegistryString(TCHAR szValue[], TCHAR szBuffer[], int ccBytes)
{
	TCHAR szRegKey[256]; HKEY hKey = NULL;

	LoadString(hInst, IDS_REGKEY_PREFIX, 
			   szRegKey, sizeof(szRegKey)/sizeof(TCHAR));
	
	long lRes = RegOpenKeyEx(HKEY_CURRENT_USER, szRegKey, 0, 0, &hKey);

	if (lRes == ERROR_SUCCESS)
	{
		DWORD dwType = REG_SZ, dwSize = ccBytes;
		lRes = RegQueryValueEx(hKey, szValue, NULL, &dwType, (LPBYTE)szBuffer, &dwSize);

		RegCloseKey(hKey);
	}
	
	return 0;
}

BOOL WriteRegistryString(TCHAR szValue[], TCHAR szBuffer[])
{
	TCHAR szRegKey[256]; HKEY hKey = NULL;

	LoadString(hInst, IDS_REGKEY_PREFIX, 
			   szRegKey, sizeof(szRegKey)/sizeof(TCHAR));
	
	long lRes = RegOpenKeyEx(HKEY_CURRENT_USER, szRegKey, 0, 0, &hKey);

	if (lRes != ERROR_SUCCESS)
	{
		DWORD dwDisposition = NULL;
		lRes = RegCreateKeyEx(HKEY_CURRENT_USER, szRegKey, 0, NULL, 0, 0, NULL, 
							  &hKey, &dwDisposition);
	}

	if (lRes == ERROR_SUCCESS)
	{
		lRes = RegSetValueEx(hKey, szValue, 0, REG_SZ, 
							(LPBYTE)szBuffer, (lstrlen(szBuffer)+1)*sizeof(TCHAR));

		RegCloseKey(hKey);
	}
	
	return 0;
}

BOOL CheckASCII(TCHAR *lpszText)
{
	// check text for non ascii chars

	int nLen = _tcslen(lpszText);
	for (int i=0; i<nLen; i++)
		if (lpszText[i] & (~0x7F))
	
			// there are non-ascii characters
			return FALSE;

	// there are no non-ascii characters
	return TRUE;
}

char *ConvertAddress(TCHAR *lpszAddress)
{
	if (! lpszAddress) return NULL;

	TCHAR szBuffer[16]; 
	memset(szBuffer, 0, sizeof(szBuffer));

	// copy all significant characters
	int nLen = _tcslen(lpszAddress);
	for (int i=0, j=0; i<nLen; i++)
		if (isdigit(lpszAddress[i]))
			szBuffer[j++] = lpszAddress[i];
		
	if (_tcslen(szBuffer) != 11) return NULL;
	_tcscat(szBuffer, _T("F"));

	static char szField[16];
	strcpy(szField, "91XXXXXXXXXXXX");

	for (i=0, j=0; i<6; i++, j+=2)
	{
		szField[j+2] = (BYTE)szBuffer[j+1];
		szField[j+3] = (BYTE)szBuffer[j];
	}

	return szField;
}

char *Convert7bitText(TCHAR *lpszText)
{
	static char szBuffer[256];
	
	int nLen = _tcslen(lpszText);
	sprintf(szBuffer, "%02X", nLen);
	
	unsigned char ucPrev = ((unsigned char)(lpszText[0]) & 0x7F);
	for (int i=1, s=7; i<nLen; i++)
	{
		if (s > 0)
		{
			unsigned uWord = lpszText[i] << s--;
			unsigned char ucByte = ucPrev | ((unsigned char)uWord & 0xFF);

			char szByte[4] = "";
			sprintf(szByte, "%02X", ucByte);
			strcat(szBuffer, szByte);

			ucPrev = (unsigned char)((uWord >> 8) & 0xFF);
		}
		else
		{
			ucPrev = ((unsigned char)(lpszText[i]) & 0x7F);
			s = 7;
		}
	}

	if (s)
	{
		char szByte[4] = "";
		sprintf(szByte, "%02X", ucPrev);
		strcat(szBuffer, szByte);
	}

	return szBuffer;
}

char *ConvertUSC2Text(TCHAR *lpszText)
{
	static char szBuffer[512];
	
	int nLen = _tcslen(lpszText);
	sprintf(szBuffer, "%02X", nLen*2);

	for (int i=0; i<nLen; i++)
	{
		unsigned uChar = lpszText[i];
		if ((uChar >= 192) && (uChar < 256)) uChar += 848;
		else if (uChar == 168) uChar = 1025;
		else if (uChar == 184) uChar = 1105;

		char szSymbol[8];
		sprintf(szSymbol, "%04X", uChar);
		strcat(szBuffer, szSymbol);
	}

	return szBuffer;
}

char *ConvertText(TCHAR *lpszText, int nEncoding)
{
	switch(nEncoding)
	{
		case 1: return ConvertUSC2Text(lpszText);
	}

	return Convert7bitText(lpszText);
}

char *BuildPDU(TCHAR *lpszSCA, TCHAR *lpszAddress, TCHAR *lpszText)
{
	static char szPDU[256];
	strcpy(szPDU, "07");
	strcat(szPDU, ConvertAddress(lpszSCA));
	strcat(szPDU, "11000B");
	strcat(szPDU, ConvertAddress(lpszAddress));
	strcat(szPDU, "00");
	
	int nEncoding = 0;
	if (! CheckASCII(lpszText)) 
	{
		nEncoding = 1;
		strcat(szPDU, "08");
	}
	else strcat(szPDU, "00");

	strcat(szPDU, "AA");
	strcat(szPDU, ConvertText(lpszText, nEncoding));

	return szPDU;
}

int GetRemaining(TCHAR *lpszText)
{
	int nLen = _tcslen(lpszText);
	int nMax = CheckASCII(lpszText) ? 160 : 70;

	if (nLen > nMax) 
	{
		if ((lpszText[nMax-1] == _T('\r')) &&
			(lpszText[nMax] == _T('\n'))) nLen = nMax-1;
		else nLen = nMax;

		lpszText[nLen] = _T('\0');
	}

	return nMax - nLen;
}

HANDLE OpenCommPort(HWND hWnd)
{
	TCHAR szPortName[32];
	LoadString(hInst, IDS_PORT_NAME, szPortName, 
			   sizeof(szPortName)/sizeof(TCHAR));
	HANDLE hPort = INVALID_HANDLE_VALUE;

	// Open the serial port.
	hPort = CreateFile (szPortName,  // Pointer to the name of the port
						GENERIC_READ | GENERIC_WRITE,
									   // Access (read-write) mode
						0,             // Share mode
						NULL,          // Pointer to the security attribute
						OPEN_EXISTING, // How to open the serial port
						0,             // Port attributes
						NULL);         // Handle to port with attribute
				                       // to copy

	if (hPort == INVALID_HANDLE_VALUE)
	{
		TCHAR tcMsgBuf[1024] = _T("");
		DWORD dwErrorCode = GetLastError();
		TCHAR szError[256], szCaption[256];
		
		LoadString(hInst, IDS_PORT_CAPTION, szCaption, 
				   sizeof(szCaption)/sizeof(TCHAR));

		switch(dwErrorCode)
		{
			case 2:
				{
					TCHAR szBuffer[256];
					LoadString(hInst, IDS_PORT_WRONG, szBuffer, 
							   sizeof(szBuffer)/sizeof(TCHAR));
					wsprintf(szError, szBuffer, szPortName);
				}
				break;

			case 55:
				{
					LoadString(hInst, IDS_PORT_CAPTURED, szError, 
							   sizeof(szError)/sizeof(TCHAR));
				}
				break;

			default:
				{
					TCHAR szBuffer[256];
					LoadString(hInst, IDS_PORT_ERROR, szBuffer, 
							   sizeof(szBuffer)/sizeof(TCHAR));
					wsprintf(szError, szBuffer, dwErrorCode);
				}
				break;
		}

		MessageBuzzer(MB_ICONHAND);
		MessageBox(hWnd, szError, szCaption, MB_OK | MB_ICONHAND);
	}
	else
	{
		DCB PortDCB;

		// Initialize the DCBlength member. 
		PortDCB.DCBlength = sizeof (DCB); 

		// Get the default port setting information.
		GetCommState (hPort, &PortDCB);

		// Change the DCB structure settings.
		PortDCB.BaudRate = 19200;             // Current baud 
		PortDCB.fBinary = TRUE;               // Binary mode; no EOF check 
		PortDCB.fParity = TRUE;               // Enable parity checking 
		PortDCB.fOutxCtsFlow = FALSE;         // No CTS output flow control 
		PortDCB.fOutxDsrFlow = FALSE;         // No DSR output flow control 
		PortDCB.fDtrControl = DTR_CONTROL_ENABLE; 
											  // DTR flow control type 
		PortDCB.fDsrSensitivity = FALSE;      // DSR sensitivity 
		PortDCB.fTXContinueOnXoff = TRUE;     // XOFF continues Tx 
		PortDCB.fOutX = FALSE;                // No XON/XOFF out flow control 
		PortDCB.fInX = FALSE;                 // No XON/XOFF in flow control 
		PortDCB.fErrorChar = FALSE;           // Disable error replacement 
		PortDCB.fNull = FALSE;                // Disable null stripping 
		PortDCB.fRtsControl = RTS_CONTROL_ENABLE; 
											  // RTS flow control 
		PortDCB.fAbortOnError = FALSE;        // Do not abort reads/writes on 
											  // error
		PortDCB.ByteSize = 8;                 // Number of bits/byte, 4-8 
		PortDCB.Parity = NOPARITY;            // 0-4=no,odd,even,mark,space 
		PortDCB.StopBits = ONESTOPBIT;        // 0,1,2 = 1, 1.5, 2 

		// Configure the port according to the specifications of the DCB 
		// structure.
		if (!SetCommState (hPort, &PortDCB))
		{
			// Display the string.
			// Display the error string.
			TCHAR szError[256], szCaption[256];

			LoadString(hInst, IDS_PORT_CAPTION, szCaption, 
					   sizeof(szCaption)/sizeof(TCHAR));
			LoadString(hInst, IDS_SETCOMMSTATE_ERROR,
					   szError, sizeof(szError)/sizeof(TCHAR));
								
			MessageBuzzer(MB_ICONHAND);
			MessageBox(hWnd, szError, szCaption, MB_OK | MB_ICONHAND);

			CloseHandle(hPort);
			return INVALID_HANDLE_VALUE;
		}

		// Retrieve the time-out parameters for all read and write operations
		// on the port. 
		COMMTIMEOUTS CommTimeouts;
		GetCommTimeouts (hPort, &CommTimeouts);

		// Change the COMMTIMEOUTS structure settings.
		CommTimeouts.ReadIntervalTimeout = MAXDWORD;  
		CommTimeouts.ReadTotalTimeoutMultiplier = 0;  
		CommTimeouts.ReadTotalTimeoutConstant = 0;    
		CommTimeouts.WriteTotalTimeoutMultiplier = 100;  
		CommTimeouts.WriteTotalTimeoutConstant = 1000;    

		// Set the time-out parameters for all read and write operations
		// on the port. 
		if (!SetCommTimeouts (hPort, &CommTimeouts))
		{
			// Display the error string.
			TCHAR szError[256], szCaption[256];

			LoadString(hInst, IDS_PORT_CAPTION, szCaption, 
					   sizeof(szCaption)/sizeof(TCHAR));
			LoadString(hInst, IDS_SETTIMEOUTS_ERROR,
					   szError, sizeof(szError)/sizeof(TCHAR));
								
			MessageBuzzer(MB_ICONHAND);
			MessageBox(hWnd, szError, szCaption, MB_OK | MB_ICONHAND);

			CloseHandle(hPort);
			return INVALID_HANDLE_VALUE;
		}
			
		// drop DTR for half of second to reset the modem
		EscapeCommFunction(hPort, SETDTR);
		EscapeCommFunction(hPort, CLRDTR);
		EscapeCommFunction(hPort, CLRRTS);

		DWORD dwStart = GetTickCount();
		while ((GetTickCount() - dwStart) < 500);

		EscapeCommFunction(hPort, SETDTR);
		EscapeCommFunction(hPort, SETRTS);

		dwStart = GetTickCount();
		while ((GetTickCount() - dwStart) < 500);
	}

	return hPort;
}

BOOL SendBytes(HWND hWnd, HANDLE hPort, char *szBytes)
{
	DWORD dwBytes = strlen(szBytes), dwWritten = 0;
	if ((! WriteFile(hPort, szBytes, dwBytes, &dwWritten, NULL)) || 
		(dwBytes != dwWritten))
	{
		TCHAR szError[256], szCaption[256];

		LoadString(hInst, IDS_COMM_CAPTION, szCaption, 
				   sizeof(szCaption)/sizeof(TCHAR));
		LoadString(hInst, IDS_PORTWRITE_ERROR,
				   szError, sizeof(szError)/sizeof(TCHAR));
							
		MessageBuzzer(MB_ICONHAND);
		MessageBox(hWnd, szError, szCaption, MB_OK | MB_ICONHAND);

		return FALSE;
	}

	return TRUE;
}

BOOL WaitResponse(HWND hWnd, HANDLE hPort, char *szResponse, DWORD dwTimeout)
{
	char szBuffer[4096], szBytes[256]; 
	DWORD dwBytesRead = 0;
	
	strcpy(szBuffer, ""); DWORD dwTicks = GetTickCount();
	while ((GetTickCount() - dwTicks) < dwTimeout)
	{
		dwBytesRead = 0;
		if (! ReadFile(hPort, szBytes, sizeof(szBytes)-1, &dwBytesRead, NULL))
		{
			TCHAR szError[256], szCaption[256];

			LoadString(hInst, IDS_COMM_CAPTION, szCaption, 
					   sizeof(szCaption)/sizeof(TCHAR));

			LoadString(hInst, IDS_PORTREAD_ERROR,
					   szError, sizeof(szError)/sizeof(TCHAR));
								
			MessageBuzzer(MB_ICONHAND);
			MessageBox(hWnd, szError, szCaption, MB_OK | MB_ICONHAND);

			return FALSE;
		}

		if (dwBytesRead > 0)
		{
			szBytes[dwBytesRead] = '\0';
			strcat(szBuffer, szBytes);

			if (strstr(szBuffer, szResponse) >= 0)
				return TRUE;
		}
	}

	return FALSE;
}

void WaitTime(WORD dwMilliseconds)
{
	DWORD dwTicks = GetTickCount();
	while ((GetTickCount() - dwTicks) < dwMilliseconds)
	{
		Sleep(10);
	}
}

void CheckPhone(HWND hWnd)
{
	HCURSOR hcrsOld = SetCursor(LoadCursor(NULL, IDC_WAIT));
	ShowCursor(TRUE);

	int nRetries = 3;
	while (nRetries > 0)
	{
		HANDLE hPort = OpenCommPort(hWnd);

		if (hPort == INVALID_HANDLE_VALUE)
		{
			ShowCursor(FALSE);
			SetCursor(hcrsOld);
			return;
		}

		WaitTime(500);

		SendBytes(hWnd, hPort, "AT\r");

		WaitTime(100);

		if (! WaitResponse(hWnd, hPort, "OK\r\n", 3000))
		{
			if (--nRetries <= 0)
			{
				TCHAR szError[256], szCaption[256];

				LoadString(hInst, IDS_COMM_CAPTION, szCaption, 
						   sizeof(szCaption)/sizeof(TCHAR));

				LoadString(hInst, IDS_NO_PHONE_ERROR,
						   szError, sizeof(szError)/sizeof(TCHAR));
							
				MessageBuzzer(MB_ICONHAND);
				MessageBox(hWnd, szError, szCaption, MB_OK | MB_ICONHAND);
			}
		}
		else nRetries = 0;

		if (hPort != INVALID_HANDLE_VALUE)
		{
			CloseHandle(hPort);
		}

		if (nRetries > 0) WaitTime(500);
	}

	ShowCursor(FALSE);
	SetCursor(hcrsOld);
}

void CheckSettings(HWND hWnd)
{
	TCHAR szSCA[256] = _T("");
	GetRegistryString(TEXT("SCA"), szSCA, sizeof(szSCA)/sizeof(TCHAR));

	if (ConvertAddress(szSCA) == NULL)
	{
		TCHAR szCaption[256] = _T("");
		LoadString(hInst, IDS_SCA_CAPTION,
				   szCaption, sizeof(szCaption)/sizeof(TCHAR));

		TCHAR szError[256] = _T("");
		LoadString(hInst, IDS_WRONG_ADDRESS,
				   szError, sizeof(szError)/sizeof(TCHAR));
							
		MessageBuzzer(MB_ICONHAND);
		MessageBox(hWnd, szError, szCaption, MB_OK | MB_ICONHAND);

		return;
	}

}

void SendPDU(HWND hWnd, char *lpszPDU)
{
	HCURSOR hcrsOld = SetCursor(LoadCursor(NULL, IDC_WAIT));
	ShowCursor(TRUE);

	char szCommand[1024] = "AT\r";
	HANDLE hPort = INVALID_HANDLE_VALUE;

	int nRetries = 3;
	while (nRetries > 0)
	{
		hPort = OpenCommPort(hWnd);
		if (hPort == INVALID_HANDLE_VALUE)
		{
			ShowCursor(FALSE);
			SetCursor(hcrsOld);
			return;
		}

		WaitTime(500);

		strcpy(szCommand, "AT+CMGF=0\r"); 
		if (! SendBytes(hWnd, hPort,  szCommand))
		{
			CloseHandle(hPort);
			ShowCursor(FALSE);
			SetCursor(hcrsOld);
			return;
		}

		WaitTime(100);

		if (! WaitResponse(hWnd, hPort, "OK\r\n", 3000))
		{
			if (--nRetries <= 0)
			{
				TCHAR szError[256], szCaption[256];

				LoadString(hInst, IDS_PORT_CAPTION, szCaption, 
						   sizeof(szCaption)/sizeof(TCHAR));

				LoadString(hInst, IDS_PDU_NOTSUPPORTED,
						   szError, sizeof(szError)/sizeof(TCHAR));
								
				MessageBuzzer(MB_ICONHAND);
				MessageBox(hWnd, szError, szCaption, MB_OK | MB_ICONHAND);

				CloseHandle(hPort);
				ShowCursor(FALSE);
				SetCursor(hcrsOld);
				return;
			}
			else
			{
				CloseHandle(hPort);
			}
		}
		else nRetries = 0;
	
		WaitTime(500);
	}

	sprintf(szCommand, "AT+CMGS=%d\r", (int)(strlen(lpszPDU)/2)); 
	if (! SendBytes(hWnd, hPort,  szCommand))
	{
		CloseHandle(hPort);
		ShowCursor(FALSE);
		SetCursor(hcrsOld);
		return;
	}

	WaitTime(100);

	if (! WaitResponse(hWnd, hPort, ">", 3000))
	{
		TCHAR szError[256], szCaption[256];

		LoadString(hInst, IDS_COMM_CAPTION, szCaption, 
				   sizeof(szCaption)/sizeof(TCHAR));

		LoadString(hInst, IDS_SMS_TRANSMIT_ERROR,
				   szError, sizeof(szError)/sizeof(TCHAR));
								
		MessageBuzzer(MB_ICONHAND);
		MessageBox(hWnd, szError, szCaption, MB_OK | MB_ICONHAND);

		CloseHandle(hPort);
		ShowCursor(FALSE);
		SetCursor(hcrsOld);
		return;
	}

	WaitTime(100);

	if (! SendBytes(hWnd, hPort, lpszPDU))
	{
		CloseHandle(hPort);
		ShowCursor(FALSE);
		SetCursor(hcrsOld);
		return;
	}
	
	WaitTime(100);

	if (! SendBytes(hWnd, hPort, "\x1A\r"))
	{
		CloseHandle(hPort);
		ShowCursor(FALSE);
		SetCursor(hcrsOld);
		return;
	}
	
	WaitTime(100);

	if (! WaitResponse(hWnd, hPort, "OK\r\n", 3000))
	{
		TCHAR szError[256], szCaption[256];

		LoadString(hInst, IDS_COMM_CAPTION, szCaption, 
				   sizeof(szCaption)/sizeof(TCHAR));

		LoadString(hInst, IDS_SMS_SEND_ERROR,
				   szError, sizeof(szError)/sizeof(TCHAR));
								
		MessageBuzzer(MB_ICONHAND);
		MessageBox(hWnd, szError, szCaption, MB_OK | MB_ICONHAND);

		CloseHandle(hPort);
		ShowCursor(FALSE);
		SetCursor(hcrsOld);
		return;
	}
	else
	{
		TCHAR szError[256], szCaption[256];

		LoadString(hInst, IDS_APP_CAPTION, szCaption, 
				   sizeof(szCaption)/sizeof(TCHAR));

		LoadString(hInst, IDS_SUCCESS,
				   szError, sizeof(szError)/sizeof(TCHAR));
								
		MessageBuzzer(MB_ICONHAND);
		MessageBox(hWnd, szError, szCaption, MB_OK | MB_ICONINFORMATION);
	}

	if (hPort != INVALID_HANDLE_VALUE)
	{
		CloseHandle(hPort);
	}

	ShowCursor(FALSE);
	SetCursor(hcrsOld);
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static HWND hWndCSOBar = NULL;				// CSOBar's window handle
	static HWND phWndControls[4] = { NULL, NULL, NULL, NULL };

	switch (message) 
	{
		case WM_COMMAND:
		{
			int wmId    = LOWORD(wParam); 
			int wmEvent = HIWORD(wParam); 
			switch (wmId)
			{
				case CSOBAR_ADORNMENTID_CLOSE:
				{
#ifdef	_WIN32_WCE
					HCURSOR	hCursor= SetCursor(LoadCursor(NULL, IDC_WAIT));	// Sandglass
					CGDFlushRegistry();										// Save registry
					SetCursor(hCursor);										// End Sandglass
					CoshMainMenuExec(hWnd);									// start Menu
#endif
					DestroyWindow(hWnd);
					return(0);
				}

				case CSOBAR_ADORNMENTID_HELP:
				{
#ifdef	_WIN32_WCE
					TCHAR fileName[MAX_PATH + 1] = _T("");
					DWORD fineNameSize;
					fineNameSize = GetModuleFileName(NULL, fileName, MAX_PATH);
					if (fineNameSize){
						FilenameCutFileName(fileName);
						TCHAR temp[MAX_PATH + 3] = _T("");
						TCHAR helpfile[MAX_PATH + 3] = _T("");
						LoadString(hInst, IDS_HELP_FILENAME,
								   helpfile, sizeof(helpfile)/sizeof(TCHAR));
						_stprintf(temp, _T("\"%s%s\""), fileName, helpfile);
						PROCESS_INFORMATION	pi;
						memset(&pi, 0, sizeof(PROCESS_INFORMATION));
						CreateProcess(_T("PegHelp.exe"), temp, NULL, NULL, FALSE, 0, NULL, NULL, NULL, &pi);
					}
#endif
					return(0);
				}

				case ID_SETUP:
					{
						DialogBox(hInst,
								  MAKEINTRESOURCE(IDD_SETUPDLG),
								  hWnd,
								  (DLGPROC)SetupDlgProc);
					}
					break;

				case ID_LEFT_ARROW:
				{
					long lIndex = SendMessage(phWndControls[1], CB_GETCURSEL, 0, 0);
					TCHAR szAddress[256] = _T("");
					if (lIndex < 0)
						SendMessage(phWndControls[1], WM_GETTEXT, sizeof(szAddress)/sizeof(TCHAR), (LPARAM)szAddress);
					else
					{
						TCHAR *lpData = (TCHAR *)SendMessage(phWndControls[1], CB_GETITEMDATA, lIndex, 0);
						if (lpData != NULL)
							lstrcpy(szAddress, lpData);
					}

					char *pAddress = ConvertAddress(szAddress);
					if (! pAddress)
					{
						TCHAR szCaption[256] = _T("");
						LoadString(hInst, IDS_ADDRESS_CAPTION,
								   szCaption, sizeof(szCaption)/sizeof(TCHAR));

						TCHAR szError[256] = _T("");
						LoadString(hInst, IDS_WRONG_ADDRESS,
								   szError, sizeof(szError)/sizeof(TCHAR));
						
						MessageBuzzer(MB_ICONHAND);
						MessageBox(hWnd, szError, szCaption, MB_OK | MB_ICONHAND);

						return 0;
					}

					TCHAR szSCA[256] = _T("");
					GetRegistryString(TEXT("SCA"), szSCA, sizeof(szSCA)/sizeof(TCHAR));

					TCHAR szText[1024] = _T("");
					SendMessage(phWndControls[3], WM_GETTEXT, sizeof(szText)/sizeof(TCHAR), (LPARAM)szText);
					
					char *pPDU = BuildPDU(szSCA, szAddress, szText);
					if (! pPDU)
					{
						TCHAR szCaption[256] = _T("");
						LoadString(hInst, IDS_PDU_CAPTION,
								   szCaption, sizeof(szCaption)/sizeof(TCHAR));

						TCHAR szError[256] = _T("");
						LoadString(hInst, IDS_PDU_ERROR,
								   szError, sizeof(szError)/sizeof(TCHAR));
						
						MessageBuzzer(MB_ICONHAND);
						MessageBox(hWnd, szError, szCaption, MB_OK | MB_ICONHAND);

						return 0;
					}

					TCHAR szConfirm[256] = _T("");
					LoadString(hInst, IDS_CONFIRM_CAPTION,
							   szConfirm, sizeof(szConfirm)/sizeof(TCHAR));

					TCHAR szQuestionFormat[256] = _T("");
					LoadString(hInst, IDS_SEND_CONFIRM,
							   szQuestionFormat, sizeof(szQuestionFormat)/sizeof(TCHAR));
					TCHAR szQuestion[512] = _T("");
					_stprintf(szQuestion, szQuestionFormat, szAddress);
					
					MessageBuzzer(MB_ICONQUESTION);
					if (MessageBox(hWnd, szQuestion, szConfirm, MB_YESNO | MB_ICONQUESTION) != IDYES)
						return 0;

					
					SendPDU(hWnd, pPDU);

					return 0;
				}

				case ID_TEXT_EDIT:
				{
					switch (wmEvent)
					{
						case EN_CHANGE:
						{
							HWND hWndText = phWndControls[3];

							long lSize = SendMessage(hWndText, WM_GETTEXTLENGTH, 0, 0);
							TCHAR *lpText = (TCHAR *)malloc((lSize+1)* sizeof(TCHAR));
							memset(lpText, 0xDD, (lSize+1)* sizeof(TCHAR));
							long lReady = SendMessage (hWndText, WM_GETTEXT, lSize+1, (LPARAM)lpText);

							int nCurrBefore = _tcslen(lpText);
							int nRemaining = GetRemaining(lpText);
							int nCurrent = _tcslen(lpText);

							TCHAR szCaption[256], szMessage[256];
							LoadString(hInst, IDS_MESSAGE_STRING_REM,
									   szMessage, sizeof(szMessage)/sizeof(TCHAR));
							wsprintf(szCaption, szMessage, nRemaining);
							SendMessage(phWndControls[2], WM_SETTEXT, 0, (LPARAM)szCaption);

							if (nCurrent < nCurrBefore)
								SendMessage(hWndText, WM_SETTEXT, 0, (LPARAM)lpText);

							SendMessage(hWndText, EM_LIMITTEXT, nCurrent+nRemaining, 0);

							if (lpText != NULL)
								free(lpText);

							break;
						}
					}

					return DefWindowProc(hWnd, message, wParam, lParam);
				}

				default:
					return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		}

		case WM_SIZE:
		{
			if (wParam != SIZE_RESTORED)
				return DefWindowProc(hWnd, message, wParam, lParam);

			RECT rcBar;	GetWindowRect(hWndCSOBar, &rcBar);
			POINT ptBarBottom = { rcBar.right, rcBar.bottom };
			ScreenToClient(hWnd, &ptBarBottom);

			sizeControls(hWnd, rcBar.bottom, phWndControls);

			return 0;
		}

		case WM_CREATE:
		{
			if ((hWndCSOBar = casioCSOBar(hWnd, hInst)) == NULL){
				DestroyWindow(hWnd);
				return(0);
			}

			if (! createControls(hWnd, hInst, phWndControls))
				 return 0;

			CheckPhone(hWnd);
			CheckSettings(hWnd);

			SetFocus(phWndControls[3]);

			return(0);
		}

#ifdef	_WIN32_WCE
		case COSH_EXECUTEAPP:
		{
			SetForegroundWindow(hWnd);
			return(0);
		}
#endif

		case WM_PAINT:
		{
			PAINTSTRUCT	ps;
			BeginPaint(hWnd,&ps);
			EndPaint(hWnd,&ps);
			return(0);
		}

		case WM_WININICHANGE:
		{
			SIPINFO si; si.cbSize = sizeof(si);
			if (! SipGetInfo(&si)) return 0;
			
			MoveWindow(hWnd, 
					   si.rcVisibleDesktop.left,
					   si.rcVisibleDesktop.top,
					   si.rcVisibleDesktop.right - si.rcVisibleDesktop.left, 
					   si.rcVisibleDesktop.bottom - si.rcVisibleDesktop.top,
					   TRUE);
			return 0;
		}

		case WM_DESTROY:
		{
			if (hWndCSOBar)
			{
				CSOBar_Destroy(hWndCSOBar);
				hWndCSOBar = NULL;
			}

			if (phWndControls[1])
			{
				LRESULT lCount = SendMessage(phWndControls[1], CB_GETCOUNT, 0, 0);
				for (int i=0; i<lCount; i++)
				{
					TCHAR *lpPhone = (TCHAR *)SendMessage(phWndControls[1], CB_GETITEMDATA, i, 0);
					if (lpPhone == NULL) continue;
					LocalFree(lpPhone);
				}
			}

			PostQuitMessage(0);
			return(0);
		}

		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }

	return(0);
}

LRESULT CALLBACK SetupDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static	HWND	hWndDlgCSOBar 	= NULL;

	switch(message){
		case WM_INITDIALOG:
			{
				RECT rect; GetWindowRect(GetWindow (hDlg, GW_OWNER), &rect);
				SetWindowPos(hDlg, NULL, rect.left, rect.top,
							 (rect.right - rect.left), 
							 (rect.bottom - rect.top), SWP_NOZORDER);

				hWndDlgCSOBar = dialogCSOBar(hDlg, hInst);

				TCHAR szSCA[256] = _T("");
				GetRegistryString(TEXT("SCA"), szSCA, sizeof(szSCA)/sizeof(TCHAR));
				SetDlgItemText(hDlg, IDC_SCA, szSCA);
			}

			return TRUE;

		case WM_COMMAND:
			switch (LOWORD(wParam)){

				case IDOK:
					{
						TCHAR szSCA[256] = _T("");
						GetDlgItemText(hDlg, IDC_SCA, szSCA, sizeof(szSCA)/sizeof(TCHAR));

						if (ConvertAddress(szSCA) == NULL)
						{
							TCHAR szCaption[256] = _T("");
							LoadString(hInst, IDS_SCA_CAPTION,
									   szCaption, sizeof(szCaption)/sizeof(TCHAR));

							TCHAR szError[256] = _T("");
							LoadString(hInst, IDS_WRONG_ADDRESS,
									   szError, sizeof(szError)/sizeof(TCHAR));
							
							MessageBuzzer(MB_ICONHAND);
							MessageBox(hDlg, szError, szCaption, MB_OK | MB_ICONHAND);

							return TRUE;
						}

						WriteRegistryString(TEXT("SCA"), szSCA);
						CGDFlushRegistry();
					}

					EndDialog(hDlg, TRUE);
					return TRUE;

				case IDCANCEL:
					EndDialog(hDlg, TRUE);
					return TRUE;
			}
			break;

		case WM_DESTROY:
			if (hWndDlgCSOBar)
			{
				CSOBar_Destroy(hWndDlgCSOBar);
				hWndDlgCSOBar = NULL;
			}

			EndDialog(hDlg, wParam);
			return TRUE;
	}

	return FALSE;
}


